"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Agent = void 0;
const http = __importStar(require("http"));
__exportStar(require("./helpers"), exports);
function isSecureEndpoint() {
    const { stack } = new Error();
    if (typeof stack !== 'string')
        return false;
    return stack
        .split('\n')
        .some((l) => l.indexOf('(https.js:') !== -1 ||
        l.indexOf('node:https:') !== -1);
}
class Agent extends http.Agent {
    constructor(opts) {
        super(opts);
        this._defaultPort = undefined;
        this._protocol = undefined;
    }
    createSocket(req, options, cb) {
        const o = {
            ...options,
            secureEndpoint: options.secureEndpoint ?? isSecureEndpoint(),
        };
        Promise.resolve()
            .then(() => this.connect(req, o))
            .then((socket) => {
            if (socket instanceof http.Agent) {
                // @ts-expect-error `createSocket()` isn't defined in `@types/node`
                return socket.createSocket(req, o, cb);
            }
            this._currentSocket = socket;
            // @ts-expect-error `createSocket()` isn't defined in `@types/node`
            super.createSocket(req, options, cb);
        }, cb);
    }
    createConnection() {
        if (!this._currentSocket) {
            throw new Error('no socket');
        }
        return this._currentSocket;
    }
    get defaultPort() {
        if (typeof this._defaultPort === 'number') {
            return this._defaultPort;
        }
        const port = this.protocol === 'https:' ? 443 : 80;
        return port;
    }
    set defaultPort(v) {
        this._defaultPort = v;
    }
    get protocol() {
        if (typeof this._protocol === 'string') {
            return this._protocol;
        }
        const p = isSecureEndpoint() ? 'https:' : 'http:';
        return p;
    }
    set protocol(v) {
        this._protocol = v;
    }
}
exports.Agent = Agent;
//# sourceMappingURL=index.js.map